#include "layer.h"
#include "level.h"
#include "layeredstream.h"
#include "session.h"
#include "qosmanager.h"

namespace Coral {

Layer::Layer(Level* level_)
  : level(level_)
{
  //cout << "layerconstructor: levelpointer - " << level << endl;
}

card32 Layer::getBandwidth()
{
  card8 fps = (card8) (level->getFPSScale() * level->getStream()->getStartFPS());
  return fps * frameSize;
}

card8 Layer::findClass()
{
  int i=0;

  card32         neededBandwidth = getBandwidth();
  LayeredStream* stream          = level -> getStream();
  Session*       session         = stream -> getSession();

  QoSManager*    qm              = session -> getQoSManager();


  //  cout << "session:" << session << endl;
  //  cout << "layer: Qosmanager: " << qm << endl;

  //cout << "free in class 0 " << qm->getFreeBandwidthOfClass(0) << endl;
  //cout << "needed " << neededBandwidth <<endl;

  for(i=qm->getNumPrios()-1; i>=0; i--) {
    if(qm->getFreeBandwidthOfClass(i) >= neededBandwidth) {
      if(session->getLossRateOfClass(i) <= maxLossRate) {
	if(session->getDelayOfClass(i) <= level->getDelay()) {
	  //cout << "put to class " << i << endl;
	  //cout << "delay :" << session->getDelayOfClass(i) << endl;
	  qm->setFreeBandwidthOfClass(i, qm->getFreeBandwidthOfClass(i) - neededBandwidth);
	  priorityClass = i;
	  return i;
	}
      }
    }
  }
  return 255;
}

card8 Layer::getPriorityClass()
{
  return priorityClass;
}


}
