// ##########################################################################
// ####                                                                  ####
// ####                      RTP Audio Server Project                    ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### Extended Transport Info Implementation                           ####
// ####                                                                  ####
// #### Version 1.00  --  February 23, 2001                              ####
// ####                                                                  ####
// #### Copyright (C) 1999  Thomas Dreibholz                             ####
// ####               2000  Universitt Bonn, Abt. IV                    ####
// ####               2001  EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################


#include "extendedtransportinfo.h"
#include "internetaddress.h"
#include "range.h"
#include "tools.h"


namespace Coral {


// ###### Constructor #######################################################
ExtendedTransportInfo::ExtendedTransportInfo()
{
}


// ###### Reset #############################################################
void ExtendedTransportInfo::reset()
{
   TransportInfo::reset();
   for(cardinal i = 0;i < TransportInfoLevel::MaxQualityLayers;i++) {
      SrcDest[i].reset();
   }
}


// ###### Translate byte order ##############################################
void ExtendedTransportInfo::translate()
{
   TransportInfo::translate();
   for(cardinal i = 0;i < min(QualityLayers,TransportInfoLevel::MaxQualityLayers);i++) {
      SrcDest[i].translate();
   }
}


// ###### Output operator ###################################################
ostream& operator<<(ostream& os, const ExtendedTransportInfo& eti)
{
   os << (TransportInfo)eti;
   for(cardinal i = 0;i < min(eti.QualityLayers,TransportInfoLevel::MaxQualityLayers);i++) {
      cout << "Layer #" << i << ":" << endl;
      cout << eti.SrcDest[i];
   }
   return(os);
}


// ###### Comparision operator ##############################################
int ExtendedTransportInfo::operator==(const ExtendedTransportInfo& eti) const
{
   for(cardinal i = 0;i < min(QualityLayers,TransportInfoLevel::MaxQualityLayers);i++) {
      if(SrcDest[i] != eti.SrcDest[i]) {
         return(false);
      }
   }
   return((TransportInfo)*this == (TransportInfo)eti);
}


}
