package bonn.infoIV.v3d2.util;

import java.io.InputStream;
import java.io.DataInput;
import java.io.IOException;

public class ByteArrayToIntArray
{
  private static final int FIRST_BYTE  = 0xFF000000;
  private static final int SECOND_BYTE = 0x00FF0000;
  private static final int THIRD_BYTE  = 0x0000FF00;
  private static final int FOURTH_BYTE = 0x000000FF;

  protected DataInput In_ = null;

  public ByteArrayToIntArray(DataInput in)
  {
    super();
    In_=in;
  }

  public void setNewInputStream(DataInput in)
  {
    In_=in;
  }


  public void readInt(int[] a) throws IOException
  {
    byte[] b = new byte[4*a.length];
    In_.readFully(b);
    for(int i=0 ; i<a.length ; i++)
    {
      a[i]= ((((int)b[i*4]  )<<24) & FIRST_BYTE)
           +((((int)b[i*4+1])<<16) & SECOND_BYTE)
           +((((int)b[i*4+2])<< 8) & THIRD_BYTE)
           + (((int)b[i*4+3])      & FOURTH_BYTE);
    }
  }

  public static int[] toInt(byte[] b)
  {
    int[] a = new int[b.length/4];
    for(int i=0 ; i<a.length ; i++)
    {
      a[i]= ((((int)b[i*4]  )<<24) & FIRST_BYTE)
           +((((int)b[i*4+1])<<16) & SECOND_BYTE)
           +((((int)b[i*4+2])<< 8) & THIRD_BYTE)
           + (((int)b[i*4+3])      & FOURTH_BYTE);
    }
    return a;
  }

}
