/**
 * MPI-Graphics package: originaly designed and implemented by: 
 *
 * @author Robert Schneider of MPI-Saarbruecken
 *
 * further developed and changed by:
 * @author Stavros Pechlivanidis of Universitaet Bonn, Abt.IV 
 */
package mpi_graphics;

import java.io.*;
import bonn.infoIV.v3d2.util.SmartDataInputStream;
import bonn.infoIV.v3d2.util.SmartByteArrayInputStream;
import bonn.infoIV.v3d2.buffer.SyncBuffer;

abstract class Binary_Sequentiel_Loader
{
  protected String st;
  protected SmartDataInputStream Sdis_         = null; // the connection to the SyncBuffer
  protected SyncBuffer           MySyncBuffer_ = null; // the reference to the SyncBuffer


  public void connectToBuffer(SyncBuffer buffer)
  {
    MySyncBuffer_ = buffer;
    Sdis_ = new SmartDataInputStream(new SmartByteArrayInputStream(new byte[buffer.getBiggestArraySize()]));
  }

  public void changeBuffer(byte arrayId, int id)
  {
    try { Sdis_.reset(); }
    catch(IOException e) 
    { 
      System.err.println("[ERROR]: reseting Stream :" +e.getMessage() +": {in Binary_Sequential_Loader}");
    }
    Sdis_.setNewBuffer(MySyncBuffer_.get(arrayId, id));
  }

  public void open_file(String filename) throws IOException //STAVROS
  {
    //in = new DataInputStream(new FileInputStream(filename));
  }
    
  public void close_file() throws IOException
  {
    Sdis_.close();
  }
}
