#include <RTP/RTP_Packet.hh>

RTP_Packet::RTP_Packet()
{
  setVersion(RTP_VERSION);
  setPadding(false);
  setExtension(false);
  setCSRCCount(0);
  setMarker(false);
  setPayloadType(0);
  setSequenceNum(0);
  setTimestamp(0);
  setSSRC(0);
//setCSRCList(0);
}

u_int16 RTP_Packet::getVersion()     { return v;                }
u_int16 RTP_Packet::getPadding()     { return p;                }
u_int16 RTP_Packet::getExtension()   { return x;                }
u_int16 RTP_Packet::getCSRCCount()   { return cc;               }
u_int16 RTP_Packet::getMarker()      { return m;                }
u_int16 RTP_Packet::getPayloadType() { return pt;               }
u_int16 RTP_Packet::getSequenceNum() { return reverse(seq);     }
u_int32 RTP_Packet::getTimestamp()   { return reverse(ts);      }
u_int32 RTP_Packet::getSSRC()        { return reverse(ssrc);    }
//u_int32 RTP_Packet::getCSRCList()    { return csrc[0];          }

void RTP_Packet::setVersion(u_int16 version)         { v    = version;            }
void RTP_Packet::setPadding(u_int16 padding)         { p    = padding;            }
void RTP_Packet::setExtension(u_int16 extFlag)       { x    = extFlag;            }
void RTP_Packet::setCSRCCount(u_int16 CSRCCount)     { cc   = CSRCCount;          }
void RTP_Packet::setMarker(u_int16 markerBit)        { m    = markerBit;          }
void RTP_Packet::setPayloadType(u_int16 payloadType) { pt   = payloadType;        }
void RTP_Packet::setSequenceNum(u_int16 seqNumber)   { seq  = reverse(seqNumber); }
void RTP_Packet::setTimestamp(u_int32 timestamp)     { ts   = reverse(timestamp); }
void RTP_Packet::setSSRC(u_int32 syncSrc)            { ssrc = reverse(syncSrc);   }
//void RTP_Packet::setCSRCList(u_int32 contribSrc)     { csrc[0] = contribSrc;     }

u_int16 FEC_Packet::getSNBase()       { return reverse(snBase); }
u_int16 FEC_Packet::getLNRecovery()   { return reverse(lnRec);  }
u_int32 FEC_Packet::getExtensionBit() { return xBit;            }
u_int32 FEC_Packet::getPTRecovery()   { return ptRec;           }
u_int32 FEC_Packet::getMask()         { return mask;            }
u_int32 FEC_Packet::getTSRecovery()   { return reverse(tsRec);  }

void FEC_Packet::setSNBase(u_int16 base)      { snBase = reverse(base); }
void FEC_Packet::setLNRecovery(u_int16 rec)   { lnRec  = reverse(rec);  }
void FEC_Packet::setExtensionBit(u_int32 ext) { xBit   = ext;           }
void FEC_Packet::setPTRecovery(u_int32 rec)   { ptRec  = rec;           }
void FEC_Packet::setMask(u_int32 msk)         { mask   = msk;           }
void FEC_Packet::setTSRecovery(u_int32 rec)   { tsRec  = reverse(rec);  }
