#include "system.h"
#include "socket.h"
#include "internetaddress.h"
#include "timedthread.h"
#include "breakdetector.h"

#include <sys/uio.h>

using namespace RTPAudio;

void sendTest1()
{
   Socket sock(Socket::IPv6,Socket::UDP);
   InternetAddress peer("ipv6-odin:1234");
   InternetFlow flow = sock.allocFlow(peer);
   flow.setTrafficClass(0x7e);
   if(sock.connect(peer) == false) {
      exit(0);
   }

   int sd = sock.getSystemSocketDescriptor();

      char cmsgbuf[1024];
      cmsghdr* cmsg;
      socklen_t cmsglen = 0;
    	cmsg = (struct cmsghdr*)cmsgbuf;
    	cmsglen += CMSG_SPACE(sizeof(int));
    	cmsg->cmsg_len = CMSG_LEN(sizeof(int));
    	cmsg->cmsg_level = SOL_IPV6;
    	cmsg->cmsg_type = IPV6_FLOWINFO;
      card32* fl = (card32*)CMSG_DATA(cmsg);
      *fl = htonl(0x03400000 | flow.getFlowLabel());

      printf("fl=%08x\n",ntohl(*(card32 *)CMSG_DATA(cmsg)));
      int y;
/*
      printf("len=%d   %d\n",cmsglen,CMSG_LEN(4));
*/
      y = setsockopt(sd,SOL_IPV6,IPV6_PKTOPTIONS,&cmsgbuf,cmsglen);
      printf("ERGEBNIS SetFL=%d\n",y);
/*
      if(y != 0) perror("ERR="); else puts("Okay!");

      for(int z=0;z<10;z++) {
         acc->write("TST",4);
      }
*/
   sock.send("TEST",4);


//      char buffer[1024];
      char buf[102400];
      for(int i = 0;i < sizeof(buf);i++) {
         buf[i] = 0x00;
      }
      strcpy((char*)&buf,"Test...Test...Test...");
  #define INT_MAX         ((int)(~0U>>1))
cout << INT_MAX << endl;

      sockaddr_in6 adr;
      cout << peer << endl;
      if(peer.getSystemAddress((sockaddr*)&adr,sizeof(sockaddr_in6),AF_INET6) !=
         sizeof(sockaddr_in6)) {
         exit(1000);
      }


	struct iovec  iov;
	struct msghdr msg;
      	iov.iov_base = &buf;
	iov.iov_len = 1000;
	msg.msg_name = NULL;  // &adr;
	msg.msg_namelen = 0; // sizeof(sockaddr_in6);
	msg.msg_iov = &iov;
	msg.msg_iovlen = 1;
	msg.msg_flags = 0;
	msg.msg_control = &cmsgbuf;
	msg.msg_controllen = cmsglen;
	
	y = sendmsg(sd,&msg,0);
	printf("SENDTO: y=%d\n",y);
	if(y == 10) {
	   puts("OKAY!!!");
	}
	else {
           	perror("   err=");
        }


  exit(0);
}



int main(int argc, char** argv)
{
   sendTest1();

   // ====== Initialize socket ==============================================
   Socket sock(Socket::IP,Socket::TCP);
   sock.setSoReuseAddress(true);
   sock.setTCPNoDelay(true);
   InternetAddress adr(1234);
   if(sock.bind(adr) == false) {
      puts("bind!");
      exit(0);
   }


   sock.listen(5);
   for(;;) {
      Socket* acc = sock.accept();
   InternetAddress peer;
   acc->getPeerAddress(peer);
   InternetAddress peer1;
   sock.getPeerAddress(peer1);


//  acc = new Socket(Socket::IPv6,Socket::UDP);

      InternetFlow flow = acc->allocFlow(peer);
      flow.setTrafficClass(0x7e);
      cout << "PEER0: " << peer1 << endl;
      cout << "PEER:  " << peer << endl;
      cout << "FLOW:  " << flow << endl;


/*
  if(acc->connect(flow) == false) {
     puts("ERR!");
     exit(0);
  }
  acc->send("YYYY",4);
*/

      int sd = acc->getSystemSocketDescriptor();


   bool opt2 = true;
   setsockopt(sd,SOL_IP,IP_RECVTOS,&opt2,sizeof(opt2));
   int opt1 = 1;
   setsockopt(sd,SOL_IPV6,IPV6_FLOWINFO,&opt1,sizeof(opt1));
   opt1 = 1;
   setsockopt(sd,SOL_IPV6,IPV6_FLOWINFO_SEND,&opt1,sizeof(opt1));

/*
printf("SOL: %d %d\n",SOL_IPV6,IPPROTO_IPV6);

      {
         int tos = 0x0a;
         int ok = setsockopt(sd,IPPROTO_IP,IP_TOS,&tos,4);
         if(ok == -1) {
            perror("@@ Fehler: ");
         }

         int flowinfo = 1;
         ok = setsockopt(sd,IPPROTO_IPV6,IPV6_FLOWINFO,&flowinfo,4);
         if(ok == -1) {
            perror(" Fehler: ");
         }
         flowinfo = 1;
         ok = setsockopt(sd,IPPROTO_IPV6,IPV6_FLOWINFO_SEND,&flowinfo,4);
         if(ok == -1) {
            perror(" Fehler: ");
         }
         flowinfo = 1;
         ok = setsockopt(sd,IPPROTO_IPV6,IPV6_RECVERR,&flowinfo,4);
         if(ok == -1) {
            perror(" Fehler: ");
         }
      }
*/

      char cmsgbuf[1024];
      cmsghdr* cmsg;
      socklen_t cmsglen = 0;
    	cmsg = (struct cmsghdr*)cmsgbuf;
    	cmsglen += CMSG_SPACE(sizeof(int));
    	cmsg->cmsg_len = CMSG_LEN(sizeof(int));
    	cmsg->cmsg_level = SOL_IPV6;
    	cmsg->cmsg_type = IPV6_FLOWINFO;
      card32* fl = (card32*)CMSG_DATA(cmsg);
      *fl = htonl(0x00a00000 | flow.getFlowLabel());

      printf("fl=%08x\n",ntohl(*(card32 *)CMSG_DATA(cmsg)));
      int y;
/*
      printf("len=%d   %d\n",cmsglen,CMSG_LEN(4));
      y = setsockopt(sd,SOL_IPV6,IPV6_PKTOPTIONS,&cmsgbuf,cmsglen);
      printf("ERGEBNIS SetFL=%d\n",y);
      if(y != 0) perror("ERR="); else puts("Okay!");

      for(int z=0;z<10;z++) {
         acc->write("TST",4);
      }
*/


      char buffer[1024];
      char buf[1024];
      for(int i = 0;i < 1024;i++) {
         buf[i] = 0x00;
      }
      strcpy((char*)&buf,"Test...Test...Test...");

/*
      sockaddr_in6 adr;
      if(flow.getSystemAddress((sockaddr*)&adr,sizeof(sockaddr_in6),AF_INET6) !=
         sizeof(sockaddr_in6)) {
         exit(1000);
      }


	struct iovec  iov;
	struct msghdr msg;
      	iov.iov_base = &buf;
	iov.iov_len = 10;
	msg.msg_name = NULL;  // &adr;
	msg.msg_namelen = 0; // sizeof(sockaddr_in6);
	msg.msg_iov = &iov;
	msg.msg_iovlen = 1;
	msg.msg_flags = 0;
	msg.msg_control = &cmsgbuf;
	msg.msg_controllen = cmsglen;
	
	sd = acc->getSystemSocketDescriptor();
	y = sendmsg(sd,&msg,0);
	printf("SENDTO: y=%d\n",y);
	if(y == 10) {
	   puts("OKAY!!!");
	}
	else {
           	perror("   err=");
        }
	
	
	


         socklen_t len = 1024;
         int ok = getsockopt(sd,IPPROTO_IPV6,IPV6_PKTOPTIONS,&buf,&len);
         if(ok == -1) {
            perror("|| Fehler: ");
         }
         else {
           printf("ok=%d   l=%d\n",ok,len);

           cmsghdr* c = (cmsghdr*)&buf;
           printf("c:  len = %d\n",c->cmsg_len);
           printf("c:  level = %d\n",c->cmsg_level);
           printf("c:  type = %d\n",c->cmsg_type);
           int* d = (int*)CMSG_DATA(c);
           printf("c:  d0 = %08x\n",ntohl(d[0]));
         }

         int tos = 0x00;
         len = sizeof(tos);

 //        int sd0 = sock.getSystemSocketDescriptor();

         ok = getsockopt(sd,IPPROTO_IP,IP_TOS,&tos,&len);
         if(ok == -1) {
            perror("** Fehler: ");
         }
         else {
            printf("TOS=%02x\n",tos);
         }
*/


/*
      flow.setFlowLabel(0);
      cout << "PEER TEST: " << peer << endl;
      ssize_t sent = acc->sendTo("TST",4,0,peer,0x0a);
      if(sent != 4) {
         perror("   => ");
      }
*/
      acc->write("TEST",4);

      ssize_t i = acc->read((char*)&buffer,1024);
      if(i > 0) {
         cout << "MSG> " << buffer << endl;
      }
      else {
         cout << "ERROR!" << endl;
      }

      	
      const char* text = "ACK!";
      acc->write(text,strlen(text) + 1);
      if(acc != NULL) {
         i = acc->read((char*)&buffer,1024);
         if(i > 0) {
            cout << "MSG> " << buffer << endl;
         }
         else {
            cout << "ERROR!" << endl;
         }



         delete acc;
      }
   }
}
