#include "system.h"
#include "socket.h"
#include "thread.h"
#include "internetflow.h"
#include "tools.h"


using namespace RTPAudio;


class FlowLabelTest : public Thread
{
   public:
   FlowLabelTest(InternetFlow* flow);
   void run();


   private:
   InternetFlow* Flow;
   Socket        Sender;
};


FlowLabelTest::FlowLabelTest(InternetFlow* flow)
{
   if(Sender.create(Socket::IPv6,Socket::UDP,Socket::Default) == false) {
      cerr << "SOCKET FAILED!" << endl;
      exit(1);
   }
   cout << "#1: " << *flow << endl;
   InternetFlow flow2 = Sender.allocFlow((InternetAddress)*flow,flow->getFlowLabel(),IPV6_FL_S_PROCESS);
   cout << "#2: " << flow2 << endl;

   // FlowLabel mu hier fr neues Socket erneut vom Mgr geholt werden!!!!

   Flow = flow;
}

void FlowLabelTest::run()
{
   for(;;) {
      delay(1000000);
      ssize_t ok = Sender.sendTo("TEST",4,0,*Flow);
      if(ok == 4) {
         printf("%5d: ok!\n",getpid());
      }
      else {
         printf("%5d: ERROR!\n",getpid());
      }
   }
}




// ###### Main program ######################################################
int main()
{
   Socket sock(Socket::IPv6,Socket::UDP,Socket::Default);
   if(sock.ready()) {
      InternetAddress adr("ipv6-odin:1234");
      InternetFlow flow = sock.allocFlow(adr,0,IPV6_FL_S_PROCESS);
      if(flow.getFlowLabel() != 0) {
         FlowLabelTest t1(&flow);
         FlowLabelTest t2(&flow);
         t1.start();
         t2.start();
         for(;;) {
            Thread::delay(1000000);
         }
      }
   }
}
