#include "socket.h"
#include "internetaddress.h"
#include "timedthread.h"
#include "breakdetector.h"


using namespace RTPAudio;
// #### Version 1.00  --  June 22, 2000                                  ####

class SenderThread : public TimedThread
{
   public:
   SenderThread(card32 x);
   void timerEvent();

   card32 num;
   card32 count;
   card64 TS;
};


SenderThread::SenderThread(card32 x)
   : TimedThread(250000)
{
   num   = x;
   count = 0;
   TS = getMicroTime();
}


void SenderThread::timerEvent()
{
   count++;
   card64 now = getMicroTime();
   
   card64 t = now - TS;
   card64 anz = t / getInterval();
   int64 diff = (card64)count - anz;
   
   printf("ist=%d   soll=%Ld   diff=%Ld\n",count,anz,diff);
}


int main(int argc, char** argv)
{
   SenderThread sender(1);
   sender.setInterval(1000000 / 25);
   sender.start();

   for(;;) {
      Thread::delay(1000000);
   }
}
